// Programme source pour le challenge ROADEF'99
//
// Auteurs: M.E. Bouzgarrou et O. Briant
// Email: bouzgarr@imag.fr, obriant@imag.fr
//
// Ce programme ne peut pas etre utilises sans 
// l'accToulouse de ses auteurs, excepte dans le cadre 
// du challenge ROADEF'99.
//
// Date: 27-11-1998
//
// Pour avoir une version lisible et modulaire de ce programme
// veuillez contacter les auteurs.
//

#include "challenge.h"

class Angers;
class LeMans;
class Grenoble;
class Paris;
class Kourou;
class Nancy;

Angers **Lille;
LeMans **Toulouse;
bool VoironLeHavre;
bool RennesLeHavre;
int Lorient;
int Noyon;
int Start;
int End;
int MCAP;
int *Cayenne;
int RouraTotal = 0;
Kourou **FortDeFrance;
double eps = 1e-5;
char *nomInstance;

class Angers {
 public:
  Angers(int rytpe_id, int Stock, int Utime, int Mtime, int Mcap, 
	   double Crent, double Cafix, double Catd, double Cbuy, 
	   double Cstock, double Cmaint, int Maxbuy);
  int rtype_id;
  int Stock;
  int Utime;
  int Mtime;
  int Mcap;
  double Crent;
  double Cafix;
  double Catd;
  double Cbuy;
  double Cstock;
  double Cmaint;
  int Maxbuy;
  int matind;
  int slack;
  Paris *Avignon;
  Grenoble *Marseille;
};

class LeMans {
 public:
  LeMans(int order_id, int st, int et, int rq, int rtype_id);
  int order_id;
  int st;
  int et;
  int rq;
  int rtype_id;
  Grenoble *Metz;
  int Pau;
  int matind;
  int Compiegne;
  double cout;
};

class substituable {
 public:
  substituable(int n1,int n2);
  ~substituable();
  int n1;
  int n2;
  class substituable *suivant;
};

class Grenoble {
 public:
  Grenoble(Angers *Lille_, LeMans *Toulouse_);
  LeMans *o;
  Angers *r;
  int Chantilly;
  int matind;
  Grenoble *Ord_;
  Grenoble *Res_;
  int matind2;
};

class Kourou {
public :
  Kourou(Paris *v_);
  Paris *v;
  int t;
  double x;
  int Geneve;
  int Lausanne;
  int n;
  Kourou *suivant;
  Kourou *precedent;
};

class Nancy {
 public:
  Nancy(class Paris *v, LeMans *o, bool relier=true);
  Nancy(class Paris *v, Kourou *m, bool relier=true);
  int type; 
  LeMans *o;
  Kourou *m;
  Nancy *suivant;
};

class Paris {
 public:
  Paris(Angers *r_, int TunisRennes_);
  int TunisRennes;
  Angers *r;
  Nancy *Nimes;
  int d;
  double cout;
  bool nouveau;
  Paris *suivant;
};

Angers::Angers(int rtype_id_, int Stock_, int Utime_, int Mtime_, 
		   int Mcap_, double Crent_, double Cafix_, double Catd_, 
		   double Cbuy_, double Cstock_, double Cmaint_, int Maxbuy_)
{
  rtype_id = rtype_id_;
  Stock = Stock_;
  Utime = Utime_;
  Mtime = Mtime_;
  Mcap = Mcap_;
  Crent = Crent_;
  Cafix = Cafix_;
  Catd = Catd_;
  Cbuy = Cbuy_;
  Cstock = Cstock_;
  Cmaint = Cmaint_;
  Maxbuy = Maxbuy_;
  Marseille = NULL;
  matind = 0;
  Avignon = NULL;
}

LeMans::LeMans(int order_id_, int st_, int et_, int rq_, int rtype_id_) {
  order_id = order_id_;
  st = st_;
  et = et_;
  rq = rq_;
  rtype_id = rtype_id_;
  Metz = NULL;
  Pau = 0;
  Compiegne = et - st; 
}

substituable::substituable(int n1_, int n2_) 
{ n1 = n1_; n2 = n2_; suivant = NULL;}

substituable::~substituable()
{ delete suivant; }

Grenoble::Grenoble(Angers *Lille_, LeMans *Toulouse_) {
  r = Lille_;
  o = Toulouse_;
  Ord_ = r->Marseille;
  r->Marseille = this;
  Res_ = o->Metz;
  o->Metz = this;
  Chantilly = 0;
  matind2 = -2;
}

Kourou::Kourou(Paris *v_) {
  v = v_;
  t = Start-1;
  suivant = NULL;
  Geneve = Start-1;
  Lausanne = Start-1;
}

Paris::Paris(Angers *r_, int TunisRennes_) {
  TunisRennes = TunisRennes_;
  r = r_;
  suivant = r->Avignon;
  r->Avignon = this;
  Nimes = NULL;
  nouveau = true;
  d = 0;
}

Nancy::Nancy(class Paris *v, LeMans *o_, bool relier = true) { 
  type = 1; 
  o = o_; 
  m = NULL; 
  if (relier) {
    suivant = v->Nimes; 
    v->Nimes = this; 
  }
}

Nancy::Nancy(class Paris *v, Kourou *m_, 
			 bool relier = true) {
  type = 0; 
  m = m_; 
  o = NULL; 
  if (relier) {
    suivant = v->Nimes; 
    v->Nimes = this; 
  }
}

int rangeOrdDureeCrois(int gauche, int droite) {
  if (gauche < droite) {
    int g = gauche + 1;
    int d = droite;
    LeMans *tmp;
    int valeur1 = Toulouse[gauche]->Compiegne;
    int valeur2 = Toulouse[gauche]->st;
    while (g <= d) {
      while ((Toulouse[d]->Compiegne >  valeur1)||
	     (Toulouse[d]->Compiegne ==  valeur1 && Toulouse[d]->st >  valeur2))
	d--;
      while (g <= d && Toulouse[g]->Compiegne <= valeur1 &&
	     (Toulouse[g]->Compiegne < valeur1 || Toulouse[g]->st <= valeur2)) g++;
      if (g < d) {
	tmp = Toulouse[g]; Toulouse[g] = Toulouse[d]; Toulouse[d] = tmp;
	g++; d--;
      }
    }
    if (gauche != d) {
      tmp = Toulouse[gauche]; Toulouse[gauche] = Toulouse[d]; Toulouse[d] = tmp;
    }
    rangeOrdDureeCrois(gauche, d-1);
    rangeOrdDureeCrois(d+1, droite);
  }
}

int rangeOrdStCrois(int gauche, int droite) {
  if (gauche < droite) {
    int g = gauche + 1;
    int d = droite;
    LeMans *tmp;
    int valeur1 = Toulouse[gauche]->st;
    double valeur2 = Toulouse[gauche]->cout+eps;
    while (g <= d) {
      while ((Toulouse[d]->st >  valeur1)||
	     (Toulouse[d]->st ==  valeur1 && Toulouse[d]->cout >  valeur2))
	d--;
      while (g <= d && Toulouse[g]->st <= valeur1 &&
	     (Toulouse[g]->st < valeur1 || Toulouse[g]->cout <= valeur2)) g++;
      if (g < d) {
	tmp = Toulouse[g]; Toulouse[g] = Toulouse[d]; Toulouse[d] = tmp;
	g++; d--;
      }
    }
    if (gauche != d) {
      tmp = Toulouse[gauche]; Toulouse[gauche] = Toulouse[d]; Toulouse[d] = tmp;
    }
    rangeOrdStCrois(gauche, d-1);
    rangeOrdStCrois(d+1, droite);
  }
}

int rangeOrdCoutRentDecrois(int gauche, int droite) {
  if (gauche < droite) {
    int g = gauche + 1;
    int d = droite;
    LeMans *tmp;
    double valeurEps  = Toulouse[gauche]->cout - eps;
    while (g <= d) {
      while (Toulouse[d]->cout <  valeurEps) d--;
      while (g <= d && Toulouse[g]->cout >= valeurEps) g++;
      if (g < d) {
	tmp = Toulouse[g]; Toulouse[g] = Toulouse[d]; Toulouse[d] = tmp;
	g++; d--;
      }
    }
    if (gauche != d) {
      tmp = Toulouse[gauche]; Toulouse[gauche] = Toulouse[d]; Toulouse[d] = tmp;
    }
    rangeOrdCoutRentDecrois(gauche, d-1);
    rangeOrdCoutRentDecrois(d+1, droite);
  }
}

int rangeSoissonsXCrois(int gauche, int droite) {
  if (gauche < droite) {
    int g = gauche + 1;
    int d = droite;
    Kourou *tmp;
    double valeur  = FortDeFrance[gauche]->x + eps;
    while (g <= d) {
      while (FortDeFrance[d]->x >  valeur) d--;
      while (g <= d && FortDeFrance[g]->x <= valeur) g++;
      if (g < d) {
	tmp = FortDeFrance[g]; FortDeFrance[g] = FortDeFrance[d]; FortDeFrance[d] = tmp;
	g++; d--;
      }
    }
    if (gauche != d) {
      tmp = FortDeFrance[gauche]; FortDeFrance[gauche] = FortDeFrance[d]; 
      FortDeFrance[d] = tmp;
    }
    rangeSoissonsXCrois(gauche, d-1);
    rangeSoissonsXCrois(d+1, droite);
  }
}

int rangeSoissonsNCrois(int gauche, int droite) {
  if (gauche < droite) {
    int g = gauche + 1;
    int d = droite;
    Kourou *tmp;
    int valeur  = FortDeFrance[gauche]->n;
    while (g <= d) {
      while (FortDeFrance[d]->n >  valeur) d--;
      while (g <= d && FortDeFrance[g]->n <= valeur) g++;
      if (g < d) {
	tmp = FortDeFrance[g]; FortDeFrance[g] = FortDeFrance[d]; FortDeFrance[d] = tmp;
	g++; d--;
      }
    }
    if (gauche != d) {
      tmp = FortDeFrance[gauche]; FortDeFrance[gauche] = FortDeFrance[d]; 
      FortDeFrance[d] = tmp;
    }
    rangeSoissonsNCrois(gauche, d-1);
    rangeSoissonsNCrois(d+1, droite);
  }
}

struct rusage Rusage;

bool lireFichier() {
  char *nom = new char [200];
  sprintf(nom,"%s/%s.tes",repTES,nomInstance);
  FILE *f = fopen(nom,"r");
  if (f == NULL) {
    printf("Le fichier %s n'existe pas\n",nom);
    return false;
  }
  Lorient = 0;
  Noyon = 0;
  char *lineBuf = new char [200];
  while (fgets(lineBuf, 200, f)) {
    if (strncmp(lineBuf, "resource", 8) == 0) (Lorient)++;
    if (strncmp(lineBuf, "order", 5) == 0) (Noyon)++;
    if (strncmp(lineBuf, "globals", 7) == 0) 
      if (sscanf(lineBuf, "globals(%d,%d,%d)", &Start, &End, &MCAP) != 3) {
	printf("La ligne 'globals(...)' est mal ecrite\n");
	return 0;
      }
  }
  fclose(f);
  if (MCAP > 0) VoironLeHavre = true;
  else MCAP = 0;
  f = fopen(nom,"r");
  Lille = new (Angers *)[Lorient+1];
  Toulouse = new (LeMans *)[Noyon+1];
  substituable *pSub = NULL;
  while (fgets(lineBuf, 200, f)) {
    if (strncmp(lineBuf, "resource", 8) == 0) {
      int rtype_id,Stock,Utime,Mtime,Mcap,Maxbuy;
      double Crent,Cafix,Catd,Cbuy,Cstock,Cmaint;
      if (sscanf(lineBuf, "resource(%d,%d,%d,%d,%d,%lf,%lf,%lf,%lf,%lf,%lf,%d)",
		 &rtype_id, &Stock, &Utime, &Mtime, &Mcap, &Crent, &Cafix, 
		 &Catd, &Cbuy, &Cstock, &Cmaint, &Maxbuy) != 12) {
	printf("Une ligne 'resource(...)' est mal ecrite : \n%s",lineBuf);
	return 0;
      }
      else {
	if (Stock < 0) Stock = 0;
	if (Utime < 0) Utime = End-Start;
	if (Mtime < 0 || MCAP == 0) Mtime = 0;
	if (Mcap < 0 || MCAP == 0) Mcap = 0;
	if (Maxbuy < 0) Maxbuy = 0;
	if (Crent < 0) Crent = 0;
	if (Cafix < 0) Cafix = 0;
	if (Catd < 0) Catd = 0;	
	if (Cbuy < 0) Cbuy = 0;
	if (Cstock < 0) Cstock = 0;
	if (Cmaint < 0 || MCAP == 0) Cmaint = 0;
	Lille[rtype_id] = new Angers(rtype_id, Stock, Utime, Mtime, Mcap,
			  Crent, Cafix, Catd, Cbuy, Cstock, Cmaint, Maxbuy);
	if (Maxbuy > 0) RennesLeHavre = true;
      }
    }
    if (strncmp(lineBuf, "substituable", 12) == 0) {
      int r1 , r2;
      if (sscanf(lineBuf, "substituable(%d,%d)",&r1,&r2) != 2 ){
	printf("Une ligne 'substituable(...)' est mal ecrite :\n%s",lineBuf);
	return 0;
      }
      else {
	substituable *sPool = new substituable(r1,r2);
	substituable *s = pSub;
	while (s != NULL) {
	  if (s->n1 == r2) {
	    substituable *new_s = new substituable(r1,s->n2);
	    new_s->suivant = sPool;
	    sPool = new_s;
	  }
	  else if (s->n2 == r1) {
	    substituable *new_s = new substituable(s->n1,r2);
	    new_s->suivant = sPool;
	    sPool = new_s;
	  }
	  s = s->suivant;
	}
	while (sPool != NULL) {
	  r1 = sPool->n1;
	  r2 = sPool->n2;
	  s = sPool;
	  sPool = sPool->suivant;
	  substituable *s1 = NULL;
	  substituable *s2 = pSub;
	  while (s2 != NULL && 
		(s2->n1 > r1 || (s2->n1 == r1 && s2->n2 < r2))) {
	    s1 = s2;
	    s2 = s2->suivant;
	  }
	  if (s1 == NULL) {
	    s->suivant = pSub;
	    pSub = s;
	  }
	  else if (s2 == NULL || s2->n1 != r1 || s2->n2 != r2) {
	    s1->suivant = s;
	    s->suivant = s2;
	  }
	  else {
	    substituable *sDelete = s;
	    s->suivant = NULL;
	    delete sDelete;
	  }
	}
      }
    }
    if (strncmp(lineBuf, "order", 5) == 0) {
      int order_id, st, et, rq, rtype_id;
      if (sscanf(lineBuf, "order(%d,%d,%d,%d,%d)",
		 &order_id, &st, &et, &rq, &rtype_id) != 5 ){
	printf("Une ligne 'order(...)' est mal ecrite :\n",lineBuf);
	return 0;
      }
      else { 
	Toulouse[order_id] = new LeMans(order_id, st, et, rq, rtype_id);
	RouraTotal += rq;
      }
    }
  }
  fclose(f);
  for (int i = 1; i <= Noyon; i++) 
    Toulouse[i]->cout = Toulouse[i]->Compiegne * Lille[Toulouse[i]->rtype_id]->Crent;
  rangeOrdStCrois(1,Noyon);
  for (int i = Noyon; i >= 1; i--) {
    LeMans *o = Toulouse[i];
    int rtype_id = o->rtype_id;
    if (pSub != NULL) {
      substituable *s = pSub;
      while (s != NULL && s->n1 < rtype_id) s = s->suivant;
      while (s != NULL && s->n1 == rtype_id) {
	new Grenoble(Lille[s->n2],o);
	s = s->suivant;
      }
    }
    new Grenoble(Lille[rtype_id],o);
  }

  delete [] nom;
  delete [] lineBuf;
  return true;
}

void enregistreResultat() {
  char *nomFichier = new char [200];
  sprintf(nomFichier,"%s/%s.rsl",repRSL,nomInstance);
  FILE *fLilleul = fopen(nomFichier,"w");
  if (fLilleul == NULL) {
    printf("Impossible de creer le fichier %s\n",nomFichier);
    exit;
  }
  for (int i=1 ; i<=Noyon; i++) if (Toulouse[i]->Pau > 0)
    fprintf(fLilleul,"rent(%d,%d,%d)\n",
	    Toulouse[i]->rtype_id,Toulouse[i]->order_id,Toulouse[i]->Pau);
  fprintf(fLilleul,"\n");
  for (int i = 1; i <= Lorient; i++) {
    int numStock = 1;
    int numRennes = Lille[i]->Stock + 1;
    Paris *v;
    v = Lille[i]->Avignon;
    while (v != NULL) {
      if (v->TunisRennes != Start-1) 
        v->d = numRennes++;
      else 
        v->d = numStock++;
      v = v->suivant;
    }
  }
  for (int i = 1; i <= Lorient; i++) {
    Paris *v;
    v = Lille[i]->Avignon;
    while (v != NULL) {
      if (v->TunisRennes != Start-1) {
	fprintf(fLilleul,"buy(%d,%d,%d)\n",Lille[i]->rtype_id,v->TunisRennes,v->d);
      }
      v = v->suivant;
    }
  }
  fprintf(fLilleul,"\n");
  for (int i = 1; i <= Lorient; i++) {
    Paris *v;
    v = Lille[i]->Avignon;
    while (v != NULL) {
      Nancy *u = v->Nimes;
      while (u != NULL) {
	if (u->type == 1)
	  fprintf(fLilleul,"alloc(%d,%d,%d)\n",
		    Lille[i]->rtype_id,u->o->order_id,v->d);
	u = u->suivant;
      }
      v = v->suivant;
    }
  }
  fprintf(fLilleul,"\n");
  for (int i = 1; i <= Lorient; i++) {
    Paris *v;
    v = Lille[i]->Avignon;
      while (v != NULL) {
	Nancy *u = v->Nimes;
	while (u != NULL) {
	  if (u->type == 0)
	    fprintf(fLilleul,"maint(%d,%d,%d)\n",
		    Lille[i]->rtype_id,v->d,u->m->t);
	  u = u->suivant;
	}
	v = v->suivant;
      }
  }
  fprintf(fLilleul,"\n");
  fclose(fLilleul);
  delete [] nomFichier;
}

bool optimiserSansSoissons(double *obj) {
  int LorientOrd = 0;
  for (int i = 1; i <= Lorient; i++) {
    Grenoble *ro = Lille[i]->Marseille;
    while (ro != NULL) {
      ro->matind2 = -1;
      LorientOrd++;
      ro = ro->Ord_;
    }
  }
  for (int i = 1; i <= Noyon; i++) 
    Toulouse[i]->Pau = 0;
  for (int i = 1; i <= Lorient; i++) if (Lille[i]->Avignon != NULL) {
    Angers *r = Lille[i];
    Paris *v = r->Avignon;
    while (v != NULL) {
      v->nouveau = false;
      Nancy *u = v->Nimes;
      while (u != NULL) {
	if (u->type == 1) {
	  u->o->rq--;
	}
	u = u->suivant;
      }
      if (v->TunisRennes < Start) (r->Stock)--;
      else (r->Maxbuy)--;
      v = v->suivant;
    }
  }
  int mac = 0;
  int mar = 0;
  int macsz = 2*LorientOrd+Noyon;
  int marsz = Noyon+Lorient+2*LorientOrd;
  int matsz = 3*LorientOrd*LorientOrd;
  char probname[] = "probleme";
  double *objx = new double [macsz];
  double *rhsx = new double [marsz];
  char *senx = new char [marsz];
  int *matbeg = new int [macsz];
  int *matcnt = new int [macsz];
  int *matind = new int [matsz];
  double *matval = new double [matsz];
  double *bdl = new double [macsz];
  double *bdu = new double [macsz];
  int indice;
  typedef struct Alencon {
    int t;
    int matind;
    struct Alencon *suivant;
  }; 
  Alencon **Tunis = new (Alencon *) [Lorient+1];
  for (int i = 1; i <= Lorient; i++) {
    Grenoble *ro = Lille[i]->Marseille;
    Tunis[i] = NULL;
    int tAncien = -1000;
    while (ro != NULL) {
      if (tAncien != ro->o->st) {
	tAncien = ro->o->st;
	Alencon *Sousse = new Alencon;
	Sousse->suivant = Tunis[i];
	Tunis[i] = Sousse;
	Sousse->t = tAncien;
      }
      ro = ro->Ord_;
    }
  }
  indice = 0;
  for (int i = 1; i <= Noyon; i++) {
    LeMans *o = Toulouse[i];
    objx[indice] = (double) (o->Metz->r->Crent * o->Compiegne);
    bdl[indice] = 0.0;
    bdu[indice] = INFBOUND;
    indice++;
  }
  for (int i = 1; i <= Lorient; i++) {
    Alencon *Sousse = Tunis[i];
    double cbuy   = Lille[i]->Cbuy;
    double cstock = Lille[i]->Cstock;
    while (Sousse != NULL) {
      objx[indice] = (double) (cbuy + cstock * (End - Sousse->t));
      bdl[indice] = 0.0;
      bdu[indice] = INFBOUND;
      indice++;
      Sousse = Sousse->suivant;
    }
  }
  for (int i = 1; i <= Lorient; i++) {
    Grenoble *ro = Lille[i]->Marseille;
    double cafix  = Lille[i]->Cafix;
    double catd   = Lille[i]->Catd;
    while (ro != NULL) {
      objx[indice] = (double) (cafix + catd * ro->o->Compiegne);
      bdl[indice] = 0.0;
      bdu[indice] = INFBOUND;
      indice++;
      ro = ro->Ord_;
    }
  }
  mac = indice;
  indice = 0;
  for (int i = 1; i <= Noyon; i++) {
    rhsx[indice] = (double) (Toulouse[i]->rq);
    senx[indice] = 'E';
    Toulouse[i]->matind = indice;
    indice++;
  }
  for (int i = 1; i <= Lorient; i++) {
    rhsx[indice] = (double) (Lille[i]->Maxbuy);
    senx[indice] = 'L';
    Lille[i]->matind = indice;
    indice++;
  }
  for (int i = 1; i <= Lorient; i++) {
    int stock  = Lille[i]->Stock;
    Alencon *t = Tunis[i];
    while (t != NULL) {
      rhsx[indice] = (double) (stock);
      senx[indice] = 'L';
      t->matind = indice;
      indice++;
      t = t->suivant;
    }
  }
  mar = indice;
  int indmat = 0;
  int indvar = 0; 
  for (int i = 1; i <= Noyon; i++) {
    matbeg[indvar] = indmat;
    matcnt[indvar] = 1;
    matind[indmat] = Toulouse[i]->matind ;
    matval[indmat] = 1.0;
    indmat++; indvar++;
  }
  for (int i = 1; i <= Lorient; i++) {
    int indalim_r = Lille[i]->matind;
    Alencon *Sousse1 = Tunis[i];
    Alencon *Sousse2;
    while (Sousse1 != NULL) {
      matbeg[indvar] = indmat;
      matcnt[indvar] = 1;
      matind[indmat] = indalim_r;
      matval[indmat] = 1.0;
      indmat++;
      Sousse2 = Tunis[i];
      while (Sousse2 != Sousse1) {
	matind[indmat] = Sousse2->matind;
	matval[indmat] = - 1.0;
	matcnt[indvar] += 1;
	indmat++;
	Sousse2 = Sousse2->suivant;
      }
      matind[indmat] = Sousse1->matind;
      matval[indmat] = - 1.0;
      matcnt[indvar] += 1;
      indmat++;
      indvar++;
      Sousse1 = Sousse1->suivant;
    }
  }
  for (int i = 1; i <= Lorient; i++) {
    Grenoble *ro1 = Lille[i]->Marseille;
    Grenoble *ro2;
    Alencon *Sousse;
    int et_o;
    int st_o;
    int CompiegneMax_o2;
    int stMax_o2;
    int stMin_o2;
    int Mtime_r = Lille[i]->Mtime;
    int Utime_r = Lille[i]->Utime;
    while (ro1 != NULL) {
      matbeg[indvar] = indmat;
      matcnt[indvar] = 1;
      matind[indmat] = ro1->o->matind;
      matval[indmat] = 1.0;
      indmat++;
      et_o = ro1->o->et;
      st_o = ro1->o->st;
      stMin_o2 = st_o + Mtime_r;
      Sousse = Tunis[i];
      while (Sousse->t != st_o) {
	if (Sousse->t < et_o) {
       	  matind[indmat] = Sousse->matind;
	  matval[indmat] = 1.0;
	  matcnt[indvar] += 1;
	  indmat++;
	}
	Sousse = Sousse->suivant;
      }
      matind[indmat] = Sousse->matind;
      matval[indmat] = 1.0;
      matcnt[indvar] += 1;
      indmat++;
      indvar++;
      ro1 = ro1->Ord_;
    }
  }
  double *x = new double [mac];
  int pstat;
  double *piout = new double [mar];
  double *slack = new double [mar];
  double *dj = new double [mac];
  int status;
  CPXENVptr env = NULL;   
  env  = CPXopenCPLEX(&status);
  if (env == NULL) { printf("probleme d'env CPLEX\n"); exit(1); }
  CPXLPptr lp = NULL;
  lp = CPXloadlp(env,probname,mac,mar,1,objx,rhsx,senx,matbeg,
                 matcnt,matind,matval,bdl,bdu,NULL,macsz,marsz,matsz);
  if (lp == NULL) { printf("lp == NULL\n"); return false;}
  status = CPXoptimize(env, lp);
  if (status) { printf("Failed to optimize\n"); return false;}
  CPXsolution(env, lp,&pstat,obj,x,piout,slack,dj);
  if (pstat != 1)
    {printf("Le probleme n'est pas realisable\n"); return false;}  
  CPXunloadprob(env, &lp);
  status = CPXcloseCPLEX(&env);  
  indice = 0;
  int *n = new int [mac];
  bool solEntiere = true;
  for (int i = 0; i < mac && solEntiere; i++) {
    n[i] = (int) ceil(x[i]-0.1);
    if (fabs(x[i] - (double) n[i]) > eps)
      solEntiere = false;
  }


  if (!solEntiere) {
    //////////////////////////////////////////////////////////////////////
    //  ICI IL FAUT APPELER MIP
    //  PUIS REPRENDRE LA DEFINITION DU TABLEAU n, C-A-D :
    //
    //  solEntiere = true;
    //  for (int i = 0; i < mac && solEntiere; i++) {
    //    n[i] = (int) ceil(x[i]-0.1);
    //    if (fabs(x[i] - (double) n[i]) > eps)
    //      solEntiere = false;
    //  }
    //
    //  VOIR CE QU'ON FAIT SI LA SOLUTION N'EST TOUJOURS PAS ENTIERE...
    //
    //////////////////////////////////////////////////////////////////////
  }
  for (int i = 1; i <= Noyon; i++) {
    Toulouse[i]->Pau = n[indice];
    indice++;
  }
  for (int i = 1; i <= Lorient; i++) {
    Angers *r = Lille[i];
    int Stock_r = r->Stock;
    Alencon *Sousse = Tunis[i];
    while (Sousse != NULL) {
      for (int j = 0; j < n[indice]; j++) new Paris(r,Sousse->t);
      indice++;
      Sousse = Sousse->suivant;
    }
    for (int j = 0; j < Stock_r; j++) 
      new Paris(r,Start-1);
  }
  for (int i = 1; i <= Lorient; i++) {
    Grenoble *ro = Lille[i]->Marseille;
    while (ro != NULL) {
      ro->Chantilly = n[indice];
      indice++;
      ro = ro->Ord_;
    }
  }
  char *nomFichier = new char [200];
  sprintf(nomFichier,"%s/%s.rsl",repRSL,nomInstance);
  FILE *fLilleul = fopen(nomFichier,"w");
  if (fLilleul == NULL) {
    printf("Impossible de creer le fichier %s\n",nomFichier);
    return false;
  }
  indice = 0;
  for (int i = 1; i <= Noyon; i++) {
    if (n[indice] > 0) 
      fprintf(fLilleul,"rent(%d,%d,%d)\n",
	      Toulouse[i]->rtype_id,Toulouse[i]->order_id,n[indice]);
    indice++;
  }
  fprintf(fLilleul,"\n");
  for (int i = 1; i <= Lorient; i++) {
    Alencon *Sousse = Tunis[i];
    while (Sousse != NULL) {
      if (n[indice] > 0)
	fprintf(fLilleul,"buy(%d,%d,%d)\n",
		Lille[i]->rtype_id,Sousse->t,n[indice]);
      indice++;
      Sousse = Sousse->suivant;
    }
  }
  fprintf(fLilleul,"\n");
  for (int i = 1; i <= Lorient; i++) {
    Grenoble *ro = Lille[i]->Marseille;
    while (ro != NULL) {
      if (n[indice] > 0) 
	fprintf(fLilleul,"alloc(%d,%d,%d)\n",
		Lille[i]->rtype_id,ro->o->order_id,n[indice]);
      indice++;
      ro = ro->Ord_;
    }
  }
  fclose(fLilleul);
  delete [] nomFichier;
  for (int i = 1; i <= Lorient; i++) if (Lille[i]->Avignon != NULL) {
    Angers *r = Lille[i];
    Paris *v = r->Avignon;
    while (v != NULL) {
      if (!v->nouveau) {
	Nancy *u = v->Nimes;
	while (u != NULL) {
	  if (u->type == 1) {
	    u->o->rq++;
	  }
	  u = u->suivant;
	}
	if (v->TunisRennes < Start) (r->Stock)++;
	else (r->Maxbuy)++;
      }
      v = v->suivant;
    }
  }
  for (int i = 1; i <= Lorient; i++) 
    while (Tunis[i] != NULL) {
      Alencon *SousseAeffacer = Tunis[i];
      Tunis[i] = SousseAeffacer->suivant;
      delete SousseAeffacer;
    }
  delete [] objx;
  delete [] rhsx;
  delete [] senx;
  delete [] matbeg;
  delete [] matcnt;
  delete [] matind;
  delete [] matval;
  delete [] bdl;
  delete [] bdu;
  delete [] Tunis;
  delete [] x;
  delete [] piout;
  delete [] slack;
  delete [] dj;
  delete [] n;

  return true;
}

bool optimiserSansAtelier(double *obj) {
  int LorientOrd = 0;
  for (int i = 1; i <= Lorient; i++) {
    Grenoble *ro = Lille[i]->Marseille;
    while (ro != NULL) {
      ro->matind2 = -1;
      LorientOrd++;
      ro = ro->Ord_;
    }
  }
  for (int i = 1; i <= Noyon; i++) 
    Toulouse[i]->Pau = 0;
  for (int i = 1; i <= Lorient; i++) if (Lille[i]->Avignon != NULL) {
    Angers *r = Lille[i];
    Paris *v = r->Avignon;
    while (v != NULL) {
      v->nouveau = false;
      Nancy *u = v->Nimes;
      while (u != NULL) {
	if (u->type == 1) {
	  u->o->rq--;
	}
	u = u->suivant;
      }
      if (v->TunisRennes < Start) (r->Stock)--;
      else (r->Maxbuy)--;
      v = v->suivant;
    }
  }
  int mac = 0;
  int mar = 0;
  int macsz = 2*LorientOrd+Noyon;
  int marsz = Noyon+Lorient+2*LorientOrd;
  int matsz = 3*LorientOrd*LorientOrd;
  char probname[] = "probleme";
  double *objx = new double [macsz];
  double *rhsx = new double [marsz];
  char *senx = new char [marsz];
  int *matbeg = new int [macsz];
  int *matcnt = new int [macsz];
  int *matind = new int [matsz];
  double *matval = new double [matsz];
  double *bdl = new double [macsz];
  double *bdu = new double [macsz];
  int indice;
  typedef struct Alencon {
    int t;
    int matind;
    struct Alencon *suivant;
  }; 
  Alencon **Tunis = new (Alencon *) [Lorient+1];
  for (int i = 1; i <= Lorient; i++) {
    Grenoble *ro = Lille[i]->Marseille;
    Tunis[i] = NULL;
    int tAncien = -1000;
    while (ro != NULL) {
      if (tAncien != ro->o->st) {
	tAncien = ro->o->st;
	Alencon *Sousse = new Alencon;
	Sousse->suivant = Tunis[i];
	Tunis[i] = Sousse;
	Sousse->t = tAncien;
      }
      ro = ro->Ord_;
    }
  }
  indice = 0;
  for (int i = 1; i <= Noyon; i++) {
    LeMans *o = Toulouse[i];
    objx[indice] = (double) (o->Metz->r->Crent * o->Compiegne);
    bdl[indice] = 0.0;
    bdu[indice] = INFBOUND;
    indice++;
  }
  for (int i = 1; i <= Lorient; i++) {
    Alencon *Sousse = Tunis[i];
    double cbuy   = Lille[i]->Cbuy;
    double cstock = Lille[i]->Cstock;
    while (Sousse != NULL) {
      objx[indice] = (double) (cbuy + cstock * (End - Sousse->t));
      bdl[indice] = 0.0;
      bdu[indice] = INFBOUND;
      indice++;
      Sousse = Sousse->suivant;
    }
  }
  for (int i = 1; i <= Lorient; i++) {
    Grenoble *ro = Lille[i]->Marseille;
    double cafix  = Lille[i]->Cafix;
    double catd   = Lille[i]->Catd;
    while (ro != NULL) {
      objx[indice] = (double) (cafix + catd * ro->o->Compiegne);
      bdl[indice] = 0.0;
      bdu[indice] = INFBOUND;
      indice++;
      ro = ro->Ord_;
    }
  }
  mac = indice;
  indice = 0;
  for (int i = 1; i <= Noyon; i++) {
    rhsx[indice] = (double) (Toulouse[i]->rq);
    senx[indice] = 'E';
    Toulouse[i]->matind = indice;
    indice++;
  }
  for (int i = 1; i <= Lorient; i++) {
    rhsx[indice] = (double) (Lille[i]->Maxbuy);
    senx[indice] = 'L';
    Lille[i]->matind = indice;
    indice++;
  }
  for (int i = 1; i <= Lorient; i++) {
    int stock  = Lille[i]->Stock;
    Alencon *t = Tunis[i];
    while (t != NULL) {
      rhsx[indice] = (double) (stock);
      senx[indice] = 'L';
      t->matind = indice;
      indice++;
      t = t->suivant;
    }
  }
  for (int i = 1; i <= Lorient; i++) {
    Angers *r = Lille[i];
    int Stock_r  = r->Stock;
    int Mtime_r = r->Mtime;
    int Utime_r = r->Utime;
    Grenoble *ro = r->Marseille;
    while (ro != NULL) {
      int st_o = ro->o->st;
      int CompiegneMax_o2 = Utime_r - ro->o->Compiegne;
      int etMax_o2 = st_o - Mtime_r;
      Grenoble *ro2 = r->Marseille;
      while (ro2 != NULL) {
	if (ro2->o->st >= st_o) ro2 = NULL;
	else if (ro2->o->et <= st_o && ro2->o->et > etMax_o2 &&
		 ro2->o->Compiegne > CompiegneMax_o2) {
	  rhsx[indice] = (double) (Stock_r);
	  senx[indice] = 'L';
	  ro->matind2 = indice;
	  indice++;
	  ro2 = NULL;
	}
	else ro2 = ro2->Ord_;
      }
      ro = ro->Ord_;
    }
  }
  mar = indice;
  int indmat = 0;
  int indvar = 0; 
  for (int i = 1; i <= Noyon; i++) {
    matbeg[indvar] = indmat;
    matcnt[indvar] = 1;
    matind[indmat] = Toulouse[i]->matind ;
    matval[indmat] = 1.0;
    indmat++; indvar++;
  }
  for (int i = 1; i <= Lorient; i++) {
    int indalim_r = Lille[i]->matind;
    Alencon *Sousse1 = Tunis[i];
    Alencon *Sousse2;
    while (Sousse1 != NULL) {
      matbeg[indvar] = indmat;
      matcnt[indvar] = 1;
      matind[indmat] = indalim_r;
      matval[indmat] = 1.0;
      indmat++;
      Sousse2 = Tunis[i];
      while (Sousse2 != Sousse1) {
	matind[indmat] = Sousse2->matind;
	matval[indmat] = - 1.0;
	matcnt[indvar] += 1;
	indmat++;
	Sousse2 = Sousse2->suivant;
      }
      matind[indmat] = Sousse1->matind;
      matval[indmat] = - 1.0;
      matcnt[indvar] += 1;
      indmat++;
      int t1 = Sousse1->t;
      Grenoble *ro = Lille[i]->Marseille;
      while (ro != NULL) {
	if (ro->o->st >= t1 && ro->matind2 > -1) {
	  matind[indmat] = ro->matind2;
	  matval[indmat] = - 1.0;
	  matcnt[indvar] += 1;
	  indmat++;
	}
	ro = ro->Ord_;
      }
      indvar++;
      Sousse1 = Sousse1->suivant;
    }
  }
  for (int i = 1; i <= Lorient; i++) {
    Grenoble *ro1 = Lille[i]->Marseille;
    Grenoble *ro2;
    Alencon *Sousse;
    int et_o;
    int st_o;
    int CompiegneMax_o2;
    int stMax_o2;
    int stMin_o2;
    int Mtime_r = Lille[i]->Mtime;
    int Utime_r = Lille[i]->Utime;
    while (ro1 != NULL) {
      matbeg[indvar] = indmat;
      matcnt[indvar] = 1;
      matind[indmat] = ro1->o->matind;
      matval[indmat] = 1.0;
      indmat++;
      et_o = ro1->o->et;
      st_o = ro1->o->st;
      stMin_o2 = st_o + Mtime_r;
      Sousse = Tunis[i];
      while (Sousse->t != st_o) {
	if (Sousse->t < et_o) {
       	  matind[indmat] = Sousse->matind;
	  matval[indmat] = 1.0;
	  matcnt[indvar] += 1;
	  indmat++;
	}
	Sousse = Sousse->suivant;
      }
      matind[indmat] = Sousse->matind;
      matval[indmat] = 1.0;
      matcnt[indvar] += 1;
      indmat++;
      CompiegneMax_o2 = Utime_r - ro1->o->Compiegne;
      stMax_o2 = et_o + Mtime_r;
      ro2 = Lille[i]->Marseille;
      while (ro2 != NULL) 
	if (ro2->o->st >= stMax_o2) ro2 = NULL;
	else {
	  if (ro2->matind2 > -1)
	    if (ro2->o->st < et_o) {
	      if (ro2->o->st >= st_o) {
		bool aGarder;
		if (stMin_o2 <= ro2->o->st || ro2 == ro1) aGarder = true;
		else {
		  int etMin_o3 = ro2->o->st - Mtime_r;
		  int CompiegneMax_o3 = Utime_r - ro2->o->Compiegne;
		  aGarder = true;
		  Grenoble *ro3 = Lille[i]->Marseille;
		  while (aGarder && ro3 != NULL) {
		    if (ro3->o->st >= st_o) ro3 = NULL;
		    else if (ro3->o->Compiegne <= CompiegneMax_o2 && 
			     ro3->o->Compiegne > CompiegneMax_o3 &&
			     ro3->o->et > etMin_o3 && ro3->o->et <= st_o) 
		      aGarder = false;
		    else ro3 = ro3->Ord_;
		  }
		}
		if (aGarder) {	      
		  matind[indmat] = ro2->matind2;
		  matval[indmat] = 1.0;
		  matcnt[indvar] += 1;
		  indmat++;
		}
	      }
	    }
	    else 
	      if (ro2->o->Compiegne > CompiegneMax_o2) {
		matind[indmat] = ro2->matind2;
		matval[indmat] = 1.0;
		matcnt[indvar] += 1;
		indmat++;
	      }
	  ro2 = ro2->Ord_;
	}
      indvar++;
      ro1 = ro1->Ord_;
    }
  }
  double *x = new double [mac];
  int pstat;
  double *piout = new double [mar];
  double *slack = new double [mar];
  double *dj = new double [mac];
  int status;
  CPXENVptr env = NULL;   
  env  = CPXopenCPLEX(&status);
  if (env == NULL) { printf("probleme d'env CPLEX\n"); exit(1); }
  CPXLPptr lp = NULL;
  lp = CPXloadlp(env,probname,mac,mar,1,objx,rhsx,senx,matbeg,
                 matcnt,matind,matval,bdl,bdu,NULL,macsz,marsz,matsz);
  if (lp == NULL) { printf("lp == NULL\n"); return false;}
  status = CPXoptimize(env, lp);
  if (status) { printf("Failed to optimize\n"); return false;}
  CPXsolution(env, lp,&pstat,obj,x,piout,slack,dj);
  if (pstat != 1)
    {printf("Le probleme n'est pas realisable\n"); return false;}  
  CPXunloadprob(env, &lp);
  status = CPXcloseCPLEX(&env);  
  indice = 0;
  int *n = new int [mac];
  bool solEntiere = true;
  for (int i = 0; i < mac && solEntiere; i++) {
    n[i] = (int) ceil(x[i]-0.1);
    if (fabs(x[i] - (double) n[i]) > eps)
      solEntiere = false;
  }
  if (!solEntiere) {
    //////////////////////////////////////////////////////////////////////
    //  ICI IL FAUT APPELER MIP
    //  PUIS REPRENDRE LA DEFINITION DU TABLEAU n, C-A-D :
    //
    //  solEntiere = true;
    //  for (int i = 0; i < mac && solEntiere; i++) {
    //    n[i] = (int) ceil(x[i]-0.1);
    //    if (fabs(x[i] - (double) n[i]) > eps)
    //      solEntiere = false;
    //  }
    //
    //  VOIR CE QU'ON FAIT SI LA SOLUTION N'EST TOUJOURS PAS ENTIERE...
    //
    //////////////////////////////////////////////////////////////////////
  }
  for (int i = 1; i <= Noyon; i++) {
    Toulouse[i]->Pau = n[indice];
    indice++;
  }
  for (int i = 1; i <= Lorient; i++) {
    Angers *r = Lille[i];
    int Stock_r = r->Stock;
    Alencon *Sousse = Tunis[i];
    while (Sousse != NULL) {
      for (int j = 0; j < n[indice]; j++) new Paris(r,Sousse->t);
      indice++;
      Sousse = Sousse->suivant;
    }
    for (int j = 0; j < Stock_r; j++) 
      new Paris(r,Start-1);
  }
  for (int i = 1; i <= Lorient; i++) {
    Grenoble *ro = Lille[i]->Marseille;
    while (ro != NULL) {
      ro->Chantilly = n[indice];
      indice++;
      ro = ro->Ord_;
    }
  }
  for (int i = 1; i <= Lorient; i++) if (Lille[i]->Avignon != NULL) {
    Angers *r = Lille[i];
    Paris *v = r->Avignon;
    while (v != NULL) {
      if (!v->nouveau) {
	Nancy *u = v->Nimes;
	while (u != NULL) {
	  if (u->type == 1) {
	    u->o->rq++;
	  }
	  u = u->suivant;
	}
	if (v->TunisRennes < Start) (r->Stock)++;
	else (r->Maxbuy)++;
      }
      v = v->suivant;
    }
  }
  for (int i = 1; i <= Lorient; i++) 
    while (Tunis[i] != NULL) {
      Alencon *SousseAeffacer = Tunis[i];
      Tunis[i] = SousseAeffacer->suivant;
      delete SousseAeffacer;
    }
  delete [] objx;
  delete [] rhsx;
  delete [] senx;
  delete [] matbeg;
  delete [] matcnt;
  delete [] matind;
  delete [] matval;
  delete [] bdl;
  delete [] bdu;
  delete [] Tunis;
  delete [] x;
  delete [] piout;
  delete [] slack;
  delete [] dj;
  delete [] n;

  return true;
}

void calculIntervalleVoiron(int Lorient) {
  for (int i = 1; i <= Lorient; i++) {
    int Mtime_r = Lille[i]->Mtime;
    Paris *v = Lille[i]->Avignon;
    while (v != NULL) {
      Nancy *u = v->Nimes;
      int Lausanne;
      while (u != NULL) {
	if (u->type == 0) {
	  u->m->Lausanne = Lausanne;
	  u->m->Geneve = u->suivant->o->et;
	}
	else Lausanne = u->o->st;
	u = u->suivant;
      }
      v = v->suivant;
    }
  }
}

void discretiseVehicules(Kourou **pSoissons, double *obj) {
  Paris *v;
  Paris *amv;
  Paris *smv;
  Paris *slv;
  int d_o;
  int st_o; 
  int Utime_r; 
  int Mtime_r;
  int Chantilly_ro;
  for (int i = 1; i <= Lorient; i++) {
    v = Lille[i]->Avignon;
    while (v != NULL) {
      if (v->nouveau) {
	v->Nimes = NULL;
	v->d = 0;
      }
      v = v->suivant;
    }
  }
  for (int i = 1; i <= Lorient; i++) {
    Angers *r = Lille[i];
    Utime_r = r->Utime;
    Mtime_r = r->Mtime;
    Grenoble *ro = r->Marseille;
    int d_slo;
    while (ro != NULL) {
      if (ro->Chantilly > 0) {
	d_o = ro->o->Compiegne;
	d_slo = d_o;
	st_o = ro->o->st;
	Chantilly_ro = ro->Chantilly;
	for (int u = 0; u < Chantilly_ro; u++) {
	  v = r->Avignon;
          amv = NULL;
          smv = NULL;
          slv = NULL;
          while (v != NULL) {
            if (v->TunisRennes <= st_o && v->nouveau) {
              if (v->Nimes == NULL || 
                  (v->Nimes->o->et <= st_o && v->d + d_o <= Utime_r)) { 
                if (smv == NULL || v->d > smv->d) smv = v;
              }
              else if (smv == NULL && v->Nimes->o->et + Mtime_r <= st_o) {
                if (amv == NULL || v->d > amv->d) amv = v;
              }
              else if (smv == NULL && amv == NULL && 
                       st_o - v->Nimes->o->st >= Mtime_r &&
                       v->Nimes->o->Compiegne < d_slo) {
                slv = v;
                d_slo = v->Nimes->o->Compiegne;
              }
              v = v->suivant;
            }
            else v = NULL;
          }
          if (smv != NULL) {
            new Nancy(smv,ro->o);
            smv->d += d_o;
          }
          else if (amv != NULL) {
            Kourou *m = new Kourou(amv);
            new Nancy(amv,m);
            new Nancy(amv,ro->o);
            amv->d = d_o;
            m->suivant = *pSoissons;
            *pSoissons = m;
            *obj += r->Cmaint;
          }
          else {
            if (slv == NULL ) {
              ro->o->Pau++;
              ro->Chantilly--;
              *obj += ro->o->Metz->r->Crent * d_o;
              *obj -= r->Cafix + r->Catd * d_o;
            }
            else {
              LeMans *slo = slv->Nimes->o;
              slo->Pau++;
              Grenoble *rslo = slo->Metz;
              while (rslo->o != slo) rslo = rslo->Res_;
              rslo->Chantilly--;
              *obj += slo->Metz->r->Crent * slo->Compiegne;
              *obj -= r->Cafix + r->Catd * slo->Compiegne;
              slv->d -= slo->Compiegne; 
              Nancy *uAeffacer = slv->Nimes;
              slv->Nimes = slv->Nimes->suivant;
              delete uAeffacer;
              if (slv->Nimes == NULL && slv->TunisRennes != Start-1) {
                *obj -= r->Cstock * (st_o - slv->TunisRennes);
                slv->TunisRennes = st_o;
              }
              else if (slv->Nimes != NULL && slv->Nimes->type == 1
                       && slv->d + d_o > Mtime_r) {
                Kourou *m = new Kourou(slv);
                new Nancy(slv,m);
                slv->d = d_o;
                m->suivant = *pSoissons;
                *pSoissons = m;
                *obj += r->Cmaint;
              }
              else slv->d += d_o;
              new Nancy(slv,ro->o);
            }
          }
        }
      }
      ro = ro->Ord_;
    }
  }
  calculIntervalleVoiron(Lorient);
}  

bool trouverDateVoiron(Kourou *m) {
  int Mcap_r  = m->v->r->Mcap;
  int Mtime_r = m->v->r->Mtime;
  int minViolMax = 0;
  int minAire = 0;
  int tCandidat = m->Geneve;
  for (int t = tCandidat; t < tCandidat+Mtime_r; t++) {
    if (Cayenne[t] > minViolMax)
      minViolMax = Cayenne[t];
    minAire += Cayenne[t];
  }
  int violMax;
  int aire = minAire;
  int tc = tCandidat + 1;
  int tcDer = m->Lausanne - m->v->r->Mtime;
  while (tc <= tcDer && minViolMax > 0) {
    aire = aire - Cayenne[tc-1] + Cayenne[tc+Mtime_r-1];
    violMax = 0;
    for (int t = tc; t < tc+Mtime_r; t++)
      if (violMax < Cayenne[t]) violMax = Cayenne[t];
    if (violMax < minViolMax || (violMax == minViolMax && aire < minAire)) {
      minAire = aire;
      minViolMax = violMax;
      tCandidat = tc;
    }
    tc++;
  }
  m->t = tCandidat;
  bool retour = true;
  for (int t = tCandidat; t < tCandidat+Mtime_r; t++) {
    Cayenne[t] += Mcap_r;
    if (Cayenne[t] > MCAP) 
      retour = false;
  }
  return retour;
}

void effacerVoiron(Kourou *m) {
  int Mcap_r  = m->v->r->Mcap;
  int TunisFinVoiron = m->v->r->Mtime + m->t;
  for (int t = m->t; t < TunisFinVoiron; t++)
    Cayenne[t] -= Mcap_r;
}

void effectuerLesVoirons(Kourou **pSoissons, int numHeur) {
  Kourou *m; 
  bool changement;
  int tAncien;
  bool initial = true;
  int nbSoissons = 0;
  m = *pSoissons;
  while (m != NULL) { 
    nbSoissons++; 
    m = m->suivant; 
  }
  m = *pSoissons;
  for (int i = 0; i < nbSoissons; i++) {
    FortDeFrance[i] = m;
    m = m->suivant;
  }
  if (numHeur == 1) {  
    m = *pSoissons;
    while (m != NULL) { 
      m->n = m->Lausanne + m->Geneve;
      m = m->suivant; 
    }
    rangeSoissonsNCrois(0,nbSoissons-1);
    changement = true;
    while (changement) {
      changement = false;
      for (int i = 0; i < nbSoissons; i++) {
	m = FortDeFrance[i];
	if (m->v->nouveau) {
	  if (m->t >= Start) effacerVoiron(m);
	  tAncien = m->t;
	  trouverDateVoiron(m);
	  if (tAncien != m->t) changement = true;
	}
      }
      initial = false;
    }
  }
  else if (numHeur == 2) {  
    m = *pSoissons;
    while (m != NULL) { 
      m->x = (m->Lausanne - m->Geneve - m->v->r->Mtime) / (double) (m->v->r->Crent);
      m = m->suivant; 
    }
    rangeSoissonsXCrois(0,nbSoissons-1);
    changement = true;
    while (changement) {
      changement = false;
      for (int i = 0; i < nbSoissons; i++) {
	m = FortDeFrance[i];
	if (m->v->nouveau) {
	  if (m->t >= Start) effacerVoiron(m);
	  tAncien = m->t;
	  trouverDateVoiron(m);
	  if (tAncien != m->t) changement = true;
	}
      }
      initial = false;
    }
  }
  else if (numHeur == 3) {  
    m = *pSoissons;
    while (m != NULL) { 
      m->n = m->Lausanne - m->Geneve - m->v->r->Mtime;
      m = m->suivant; 
    }
    rangeSoissonsNCrois(0,nbSoissons-1);
    changement = true;
    while (changement) {
      changement = false;
      for (int i = 0; i < nbSoissons; i++) {
	m = FortDeFrance[i];
	if (m->v->nouveau) {
	  if (m->t >= Start) effacerVoiron(m);
	  tAncien = m->t;
	  trouverDateVoiron(m);
	  if (tAncien != m->t) changement = true;
	}
      }
      initial = false;
    }
  }
  else {
    switch (numHeur) {
    case 4 : {srand(47); break;}
    case 5 : {srand(266); break;}
    case 6 : {srand(2265); break;}
    case 7 : {srand(1400); break;}
    case 8 : {srand(1207); break;}
    case 9 : {srand(60); break;}
    case 10 : {srand(1288); break;}
    default : {srand(lrand48()); break;}
    }
    changement = true;
    m = *pSoissons;
    while (m != NULL) { 
      m->n = rand();
      m = m->suivant; 
    }
    rangeSoissonsNCrois(0,nbSoissons-1);
    int num = 0;
    while (changement) {
      changement = false;
      for (int i = 0; i < nbSoissons; i++) {
	m = FortDeFrance[i];
	if (m->v->nouveau) {
	  if (m->t >= Start) effacerVoiron(m);
	  tAncien = m->t;
	  trouverDateVoiron(m);
	  if (tAncien != m->t) changement = true;
	}
      }
      if (!changement) {
	num++;
	if (num < 3) { 
	  changement = true;
	  m = *pSoissons;
	  while (m != NULL) { 
	    m->n = rand();
	    m = m->suivant; 
	  }
	  rangeSoissonsNCrois(0,nbSoissons-1);
	}
      }
      else num = 0;
      initial = false;
    }
  }
}

bool CayenneAtelier(Kourou *m) {
  bool retour = false;
  int Geneve = m->t;
  int Lausanne = m->t + m->v->r->Mtime;
  int t = Geneve;
  while (!retour && t < Lausanne) 
    if (Cayenne[t] > MCAP) retour = true;
    else t++;
  return retour;
}

void rendRealisable(Kourou **pSoissons,double *obj,bool initial) {
  Kourou *m;
  for (int i = 1; i <= Lorient; i++) {
    Paris *v = Lille[i]->Avignon;
    Nancy *u;
    double x;
    while (v != NULL) {
      u = v->Nimes;
	x = 0;
	m = NULL;
	while (u != NULL) {
	  if (u->type == 1) 
	    x += u->o->cout;
	  else {
	    u->m->x = x;
	    if (m != NULL && m->x > x)
	      m->x = x;
	    m = u->m;
	    x = 0;
	  }
	  u = u->suivant;
	}
	if (m != NULL && m->x > x)
	  m->x = x;
      v = v->suivant;
    }
  }
  int nbSoissons = 0;
  m = *pSoissons;
  while (m != NULL) { nbSoissons++; m = m->suivant; }
  m = *pSoissons;
  for (int i = 0; i < nbSoissons; i++) {
    FortDeFrance[i] = m;
    m = m->suivant;
  }
  rangeSoissonsXCrois(0,nbSoissons-1);
  *pSoissons = NULL;
  for (int i = nbSoissons-1; i >= 0; i--) {
    FortDeFrance[i]->suivant = *pSoissons;
    *pSoissons = FortDeFrance[i];
  }
  m = *pSoissons;
  Kourou *mAvant = NULL;
  bool test;
  while (m != NULL) {
    test = CayenneAtelier(m);
    if (test && !m->v->nouveau) {
      mAvant = m;
      m = m->suivant;
    }
    else if (test) {
      effacerVoiron(m);
      if (!trouverDateVoiron(m)) {
	Kourou *m2 = *pSoissons;
	while (m2 != m && !(m2->v->nouveau && m2->t <= m->t 
			    && m2->t+m2->v->r->Mtime >= m->t+m->v->r->Mtime)) 
	  m2 = m2->suivant;
	if (m2 != m) {
	  m = m2;
	  if (m2 == *pSoissons) mAvant = NULL;
	  else {
	    mAvant = *pSoissons;
	    while (mAvant->suivant != m2) mAvant = mAvant->suivant;
	  }
	}
	effacerVoiron(m);
	*obj -= m->v->r->Cmaint;
	LeMans *o;
	int CompiegneAvant = 0;
	int CompiegneApLille = 0;
	Nancy *u = m->v->Nimes;
	Nancy *u_m_ApLille = NULL;
	Nancy *u_o_ApLille;
	while (u->m != m) {
	  if (u->type == 0) {
	    CompiegneApLille = 0;
	    u_m_ApLille = u;
	  }
	  else {
	    CompiegneApLille += u->o->Compiegne;
	    u_o_ApLille = u;
	  }
	  u = u->suivant;
	}
	u = u->suivant;
	while (u != NULL && u->type != 0) {
	  CompiegneAvant += u->o->Compiegne;
	  u = u->suivant;
	}
	double Cafix = m->v->r->Cafix;
	double Catd = m->v->r->Catd;
	if (CompiegneAvant > CompiegneApLille) {
	  if (u_m_ApLille == NULL) u = m->v->Nimes;
	  else u = u_m_ApLille->suivant;
	  while (u->m != m) {
	    u->o->Pau++;
	    *obj += u->o->Metz->r->Crent * u->o->Compiegne;
	    *obj -= Cafix + Catd * u->o->Compiegne;
	    u = u->suivant;
	  }
	  if (u_m_ApLille == NULL) m->v->Nimes = u->suivant;
	  else 
	    u_m_ApLille->suivant = u->suivant;
	}
	else {
	  u = u_o_ApLille->suivant->suivant;
	  while (u != NULL && u->type != 0) {
	    u->o->Pau++;
	    *obj += u->o->Metz->r->Crent * u->o->Compiegne;
	    *obj -= Cafix + Catd * u->o->Compiegne;
	    u = u->suivant;
	  }
	  u_o_ApLille->suivant = u;
	}
	if (mAvant == NULL) *pSoissons = m->suivant;
	else mAvant->suivant = m->suivant;
	m = m->suivant;
      }
      else { mAvant = m; m = m->suivant;}
    }
    else {mAvant = m;m = m->suivant;}
  }
}

class LSoissons {
public:
  LSoissons(Kourou *m_);
  ~LSoissons();
  Kourou *m;
  class LSoissons *avant;
  class LSoissons *apLille;
};

LSoissons::LSoissons(Kourou *m_) : m (m_) {}
LSoissons::~LSoissons() { delete apLille;}
LSoissons *premLSoissons;
LSoissons *dernLSoissons;

bool KourouLeHavre(int st, int et, int Mcap_r, int Mtime_r) {
  bool retour = false;
  if (st + Mtime_r > et) return false;
  int tFin = et - Mtime_r;
  int seuilViol = MCAP - Mcap_r;
  int td = st;
  while (td <= tFin && !retour) {
    retour = true;
    int t = td;
    while (retour && t < td+Mtime_r) 
      if (Cayenne[t] > seuilViol) retour = false;
      else t++;
    td++;
  }
  if (retour) return true;
  bool continuer = true;
  int tDeb_m;
  int tFin_m;
  int Mcap_m;
  int seuil_m;
  int t_m;
  LSoissons *lm1;
  LSoissons *lm2;
  LSoissons *lm3;
  LSoissons *lmAvant = premLSoissons;
  LSoissons *lmApLille = dernLSoissons;
  lm2 = lmAvant;
  do {
    lm1 = lm2;
    lm2 = lm1->apLille;
    if (lm1->m->t != lm1->m->Geneve) {
      Mcap_m = lm1->m->v->r->Mcap;
      seuil_m = MCAP - Mcap_m;
      tDeb_m = lm1->m->Geneve;
      t_m = lm1->m->t - 1;
      while (t_m >= tDeb_m && Cayenne[t_m] <= seuil_m) t_m--;
      t_m++;
      if (t_m != lm1->m->t) {
	tFin_m = lm1->m->t + lm1->m->v->r->Mtime;
	for (int t = lm1->m->t; t < tFin_m; t++)
	  Cayenne[t] -= Mcap_m;
	lm1->m->t = t_m;
	tFin_m = t_m + lm1->m->v->r->Mtime;
	for (int t = t_m; t < tFin_m; t++)
	  Cayenne[t] += Mcap_m;
	lm3 = lm1->avant;
	while (lm3 != NULL && lm3->m->t > t_m) lm3 = lm3->avant;
	if (lm3 != lm1->avant) {
	  lm1->avant->apLille = lm1->apLille;
	  if (lm1->apLille == NULL) dernLSoissons = lm1->avant;
	  else lm1->apLille->avant = lm1->avant;
	  lm1->avant = lm3;
	  if (lm3 == NULL) {
	    lm1->apLille = premLSoissons;	    
	    premLSoissons = lm1;
	  }
	  else {
	    lm1->apLille = lm3->apLille;
	    lm3->apLille = lm1;
	  }
	  lm1->apLille->avant = lm1;
	}
      }
    }
  } while (lm2 != NULL && lm1->m->t <= st);
  lmAvant = lm1;
  lm2 = lmApLille;
  do {
    lm1 = lm2;
    lm2 = lm1->avant;
    if (lm1->m->t + lm1->m->v->r->Mtime != lm1->m->Lausanne) {
      Mcap_m = lm1->m->v->r->Mcap;
      seuil_m = MCAP - Mcap_m;
      tFin_m = lm1->m->Lausanne;
      t_m = lm1->m->t + lm1->m->v->r->Mtime;
      while (t_m < tFin_m && Cayenne[t_m] <= seuil_m) t_m++;
      if (t_m != lm1->m->t + lm1->m->v->r->Mtime) {
	tFin_m = lm1->m->t + lm1->m->v->r->Mtime;
	for (int t = lm1->m->t; t < tFin_m; t++)
	  Cayenne[t] -= Mcap_m;
	tFin_m = t_m;
	t_m -= lm1->m->v->r->Mtime;
	lm1->m->t = t_m;
	for (int t = t_m; t < tFin_m; t++)
	  Cayenne[t] += Mcap_m;
	lm3 = lm1->apLille;
	while (lm3 != NULL && lm3->m->t < t_m) lm3 = lm3->apLille;
	if (lm3 != lm1->apLille) {
	  lm1->apLille->avant = lm1->avant;
	  if (lm1->avant == NULL) premLSoissons = lm1->apLille;
	  else lm1->avant->apLille = lm1->apLille;
	  lm1->apLille = lm3;
	  if (lm3 == NULL) {
	    lm1->avant = dernLSoissons;	    
	    dernLSoissons = lm1;
	  }
	  else {
	    lm1->avant = lm3->avant;
	    lm3->avant = lm1;
	  }
	  lm1->avant->apLille = lm1;
	}
      }
    }
  } while (lm2 != NULL && lm1->m->t >= st);
  int tAncien;
  td = st;
  while (td <= tFin && !retour) {
    retour = true;
    int t = td;
    while (retour && t < td+Mtime_r) 
      if (Cayenne[t] > seuilViol) retour = false;
      else t++;
    td++;
    if (!retour) {
      while (lm1 != NULL && lm1->m->t == lm1->m->Geneve) lm1 = lm1->apLille;
      if (lm1 == NULL) td = tFin+1;
      else {
	lm2 = lm1->apLille;
	Mcap_m = lm1->m->v->r->Mcap;
	seuil_m = MCAP - Mcap_m;
	tDeb_m = lm1->m->Geneve;
	t_m = lm1->m->t - 1;
	while (t_m >= tDeb_m && Cayenne[t_m] <= seuil_m) t_m--;
	t_m++;
	if (t_m != lm1->m->t) {
	  tFin_m = lm1->m->t + lm1->m->v->r->Mtime;
	  for (int tt = lm1->m->t; tt < tFin_m; tt++)
	    Cayenne[tt] -= Mcap_m;
	  lm1->m->t = t_m;
	  tFin_m = t_m + lm1->m->v->r->Mtime;
	  for (int tt = t_m; tt < tFin_m; tt++)
	    Cayenne[tt] += Mcap_m;
	  lm3 = lm1->avant;
	  while (lm3 != NULL && lm3->m->t > t_m) lm3 = lm3->avant;
	  if (lm3 != lm1->avant) {
	    lm1->avant->apLille = lm1->apLille;
	    if (lm1->apLille == NULL) dernLSoissons = lm1->avant;
	    else lm1->apLille->avant = lm1->avant;
	    lm1->avant = lm3;
	    if (lm3 == NULL) {
	      lm1->apLille = premLSoissons;	    
	      premLSoissons = lm1;
	    }
	    else {
	      lm1->apLille = lm3->apLille;
	      lm3->apLille = lm1;
	    }
	    lm1->apLille->avant = lm1;
	  }
	}
	if (lm1->m->t > td) td = lm1->m->t;
	lm1 = lm2;
      }
    }
  }
  return retour;
}

bool minimiseSousLocations(Kourou **pSoissons,double *obj) {
  bool retour = false;
  Kourou *m;
  int nbSoissons = 0;
  m = *pSoissons;
  while (m != NULL) { 
    nbSoissons++; 
    m->n = m->t;
    m = m->suivant; 
  }
  nbSoissons = 0;
  m = *pSoissons;
  while (m != NULL) {
    FortDeFrance[nbSoissons] = m;
    m = m->suivant;
    nbSoissons++;
  }

  if (nbSoissons == 0) {
    dernLSoissons = NULL;
    premLSoissons = NULL;
  }
  else {
    rangeSoissonsNCrois(0,nbSoissons-1);
    dernLSoissons = NULL;
    for (int i = 0; i < nbSoissons; i++) {
      LSoissons *lm = new LSoissons (FortDeFrance[i]);
      if (dernLSoissons != NULL) dernLSoissons->apLille = lm;
      else premLSoissons = lm;
      lm->avant = dernLSoissons;
      dernLSoissons = lm;
    }
    dernLSoissons->apLille = NULL;
    premLSoissons->avant = NULL;
  }
  LSoissons *sauvLSoissons;
  for (int i = 1; i <= Noyon; i++) if (Toulouse[i]->Pau > 0) {
    LeMans *o = Toulouse[i];
    int Compiegne_o = o->Compiegne;
    int st_o = o->st;
    int et_o = o->et;
    Grenoble *ro = o->Metz;
    while (ro != NULL && o->Pau > 0) {
      Angers *r = ro->r;
      double Cafix_r = r->Cafix;
      double Catd_r  = r->Catd;
      double Cmaint_r  = r->Cmaint;
      int Utime_r  = r->Utime;
      int Mtime_r  = r->Mtime;
      int Mcap_r  = r->Mcap;
      int seuilViol_r  = MCAP - Mcap_r;
      int etMax = st_o - Mtime_r;
      int stMin = et_o + Mtime_r;
      int dMax = Utime_r - Compiegne_o;
      if (dMax < 0) dMax = 0;
      Nancy *u_o_ApLille;
      Nancy *u_o_Avant;
      Nancy *u;
      Paris *v = r->Avignon;
      while (v != NULL) {
 	if (!v->nouveau || v->TunisRennes > st_o) v->cout = 0;
 	else {
	  u_o_ApLille = NULL;
	  u_o_Avant = NULL;
	  u = v->Nimes;
	  while (u != NULL && u_o_Avant == NULL) {
	    if (u->type == 1) 
	      if (u->o->st >= et_o) {
		if (u->o->Compiegne <= dMax || u->o->st >= stMin) 
		  u_o_ApLille = u;
	      }
	      else if (u_o_Avant == NULL && u->o->et <= st_o) 
		if (u->o->Compiegne <= dMax || u->o->et <= etMax) 
		  u_o_Avant = u;
	    u = u->suivant;
	  }
	  v->cout  = Cafix_r + Catd_r * Compiegne_o - o->cout;
	  if (u_o_ApLille == NULL) u = v->Nimes;
	  else u = u_o_ApLille->suivant;
	  while (u != u_o_Avant) {
	    if (u->type == 0) v->cout -= Cmaint_r;
	    else v->cout -= Cafix_r + Catd_r * u->o->Compiegne - u->o->cout;
	    u = u->suivant;
	  }
	}
	v = v->suivant;
      }
      double coutMin = -1;
      bool reussite = false;
      while (coutMin < 0 && o->Pau > 0) {
	m = *pSoissons;
	while (m != NULL) { m->n = m->t; m = m->suivant; }
	coutMin = 0;
	Paris *vCandidat = NULL;
	Paris *vc = r->Avignon;
	while (vc != NULL) {
	  if (vc->cout < coutMin) {
	    coutMin = vc->cout;
	    vCandidat = vc;
	  }
	  vc = vc->suivant;
	}
	if (vCandidat != NULL) {
	  bool reussite = true;
	  Nancy *u_m_ApLille = NULL;
	  Nancy *u_m_Avant = NULL;
	  u_o_ApLille = NULL;
	  u_o_Avant = NULL;
	  u = vCandidat->Nimes;
	  while (u != NULL) 
	    if (u->type == 0) 
	      if (u_o_Avant != NULL) {
		u_m_Avant = u;
		u = NULL;
	      }
	      else {
		if (u->suivant->o->st >= et_o) 
		  if (u->suivant->o->Compiegne <= dMax || 
		      u->suivant->o->st >= stMin) 
		    u_m_ApLille = u;
		u = u->suivant;
	      }
	    else {
	      if (u->o->st >= et_o) {
		if (u->o->Compiegne <= dMax || u->o->st >= stMin) 
		  u_o_ApLille = u;
	      }
	      else if (u_o_Avant == NULL && u->o->et <= st_o) 
		if (u->o->Compiegne <= dMax || u->o->et <= etMax) 
		  u_o_Avant = u;
	      u = u->suivant;
	    }
	  if (u_o_ApLille == NULL) u = vCandidat->Nimes;
	  else u = u_o_ApLille;
	  sauvLSoissons = NULL;
	  while (u != u_o_Avant) {
	    if (u->type == 0) {
	      effacerVoiron(u->m);
	      LSoissons *lm = premLSoissons;
	      while (lm->m != u->m) lm = lm->apLille;
	      if (lm->apLille == NULL) dernLSoissons = lm->avant;
	      else lm->apLille->avant = lm->avant;
	      if (lm->avant == NULL) premLSoissons = lm->apLille;
	      else lm->avant->apLille = lm->apLille;
	      lm->apLille = sauvLSoissons;
	      sauvLSoissons = lm;
	    }
	    u = u->suivant;
	  }
	  int CompiegneApLille;
	  if (u_o_ApLille == NULL) CompiegneApLille = 0;
	  else {
	    CompiegneApLille = u_o_ApLille->o->Compiegne;
	    if (u_m_ApLille == NULL) u = vCandidat->Nimes;
	    else u = u_m_ApLille->suivant;
	    while (u != u_o_ApLille) {
	      CompiegneApLille += u->o->Compiegne;
	      u = u->suivant;
	    }
	  }
	  int CompiegneAvant = 0;
	  u = u_o_Avant;
	  while (u != u_m_Avant) {
	    CompiegneAvant += u->o->Compiegne;
	    u = u->suivant;
	  }
	  Nancy *u_newmApLille_oApLille = NULL;
	  Nancy *u_newmApLille_oAvant = NULL;
	  Nancy *u_newmAvant_oApLille = NULL;
	  Nancy *u_newmAvant_oAvant = NULL;
	  LSoissons *lmNewAvant = NULL;
	  LSoissons *lmNewApLille = NULL;
	  if (CompiegneAvant + CompiegneApLille > dMax) {
	    if (u_o_Avant != NULL && 
		(CompiegneAvant > dMax || CompiegneApLille <= dMax)) {
	      if (KourouLeHavre(u_o_Avant->o->et,st_o,
				      Mcap_r,Mtime_r)) {
		CompiegneAvant = 0;
		u_newmAvant_oAvant = u_o_Avant;
	      }
	      else {
		CompiegneAvant = u_o_Avant->o->Compiegne;
		Nancy *uc = u_o_Avant;
		u = u_o_Avant->suivant;
		while (u != u_m_Avant && CompiegneAvant <= dMax && 
		       u_newmAvant_oAvant == NULL) {
		  if (KourouLeHavre(u->o->et,uc->o->st,
					  Mcap_r,Mtime_r)) {
		    u_newmAvant_oApLille = uc;
		    u_newmAvant_oAvant = u;
		  }
		  else {
		    CompiegneAvant += u->o->Compiegne;
		    uc = u;
		    u = u->suivant;
		  }
		}
	      }
	      if (u_newmAvant_oAvant != NULL) 
		vCandidat->cout += Cmaint_r;	
	      if (vCandidat->cout >= 0) reussite = false;
	      else if (u_newmAvant_oAvant != NULL) {
		Kourou *mNewAvant = new Kourou(vCandidat);
		if (u_newmAvant_oApLille == NULL)
		  mNewAvant->Lausanne = st_o;
		else mNewAvant->Lausanne = u_newmAvant_oApLille->o->st;
		mNewAvant->Geneve = u_newmAvant_oAvant->o->et;
		trouverDateVoiron(mNewAvant);
		LSoissons *lm1 = NULL;
		LSoissons *lm2 = premLSoissons;
		while (lm2 != NULL && lm2->m->t < mNewAvant->t) {
		  lm1 = lm2;
		  lm2 = lm2->apLille;
		}
		lmNewAvant = new LSoissons(mNewAvant);
		lmNewAvant->avant = lm1;
		lmNewAvant->apLille = lm2;
		if (lm1 != NULL) lm1->apLille = lmNewAvant;
		else premLSoissons = lmNewAvant;
		if (lm2 != NULL) lm2->avant = lmNewAvant;
		else dernLSoissons = lmNewAvant;
	      }
	      else if (CompiegneAvant > dMax)
		reussite = false;
	    }
	    if (reussite && u_o_ApLille != NULL && 
		CompiegneAvant + CompiegneApLille > dMax) {
	      if (KourouLeHavre(et_o,u_o_ApLille->o->st,
				      Mcap_r,Mtime_r)) {
		CompiegneApLille = 0;
		u_newmApLille_oApLille = u_o_ApLille;
	      }
	      else {
		if (u_m_ApLille == NULL) u = vCandidat->Nimes;
		else u = u_m_ApLille->suivant;
		CompiegneApLille = 0;
		while (u != u_o_ApLille) {
		  CompiegneApLille += u->o->Compiegne;
		  if (KourouLeHavre(u->suivant->o->et,u->o->st,
					  Mcap_r,Mtime_r)) {
		    u_newmApLille_oApLille = u;
		    u_newmApLille_oAvant = u->suivant;
		    CompiegneApLille = 0;
		  }
		  u = u->suivant;
		}
		CompiegneApLille += u_o_ApLille->o->Compiegne;
	      }
	    }
	    if (u_newmApLille_oApLille != NULL) vCandidat->cout += Cmaint_r;
	    if (CompiegneAvant + CompiegneApLille > dMax || vCandidat->cout >= 0)
	      reussite = false;
	    else if (u_newmApLille_oApLille != NULL) {
	      Kourou *mNewApLille = new Kourou(vCandidat);
	      if (u_newmApLille_oAvant == NULL)
		mNewApLille->Geneve = et_o;
	      else mNewApLille->Geneve = u_newmApLille_oAvant->o->et;
	      mNewApLille->Lausanne = u_newmApLille_oApLille->o->st;
	      trouverDateVoiron(mNewApLille);
	      LSoissons *lm1 = NULL;
	      LSoissons *lm2 = premLSoissons;
	      while (lm2 != NULL && lm2->m->t < mNewApLille->t) {
		lm1 = lm2;
		lm2 = lm2->apLille;
	      }
	      lmNewApLille = new LSoissons(mNewApLille);
	      lmNewApLille->avant = lm1;
	      lmNewApLille->apLille = lm2;
	      if (lm1 != NULL) lm1->apLille = lmNewApLille;
	      else premLSoissons = lmNewApLille;
	      if (lm2 != NULL) lm2->avant = lmNewApLille;
	      else dernLSoissons = lmNewApLille;
	    }
	  }
	  if (reussite) {
	    *obj += vCandidat->cout;
	    o->Pau--;
	    retour = true;
	    if (u_o_ApLille == NULL) u = vCandidat->Nimes;
	    else u = u_o_ApLille->suivant;
	    while (u != u_o_Avant) {
	      if (u->type == 0) {
		if (u->m == *pSoissons) 
		  *pSoissons = u->m->suivant;
		else {
		  Kourou *m = *pSoissons;
		  while (m->suivant != u->m) m = m->suivant;
		  m->suivant = u->m->suivant;
		}
		delete u->m;
	      }
	      else u->o->Pau++;
	      Nancy *uAeffacer = u;
	      u = u->suivant;
	      delete uAeffacer;
	    }
 	    LSoissons *lmAeffacer = sauvLSoissons;
 	    delete lmAeffacer;
	    Nancy *uo = new Nancy(vCandidat,o,false);
	    if (u_o_ApLille == NULL) vCandidat->Nimes = uo;
	    else u_o_ApLille->suivant = uo;
	    uo->suivant = u_o_Avant;
	    if (u_newmAvant_oApLille == NULL) u_newmAvant_oApLille = uo;
	    if (u_newmApLille_oAvant == NULL) u_newmApLille_oAvant = uo;
	    if (u_newmAvant_oAvant != NULL) {
	      lmNewAvant->m->suivant = *pSoissons;
	      *pSoissons = lmNewAvant->m;
	      Nancy *um = new Nancy(vCandidat,lmNewAvant->m,false);
	      u_newmAvant_oApLille->suivant = um;
	      um->suivant = u_newmAvant_oAvant;
	    }
	    if (u_newmApLille_oApLille != NULL) {
	      lmNewApLille->m->suivant = *pSoissons;
	      *pSoissons = lmNewApLille->m;
	      Nancy *um = new Nancy(vCandidat,lmNewApLille->m,false);
	      u_newmApLille_oApLille->suivant = um;
	      um->suivant = u_newmApLille_oAvant;
	    }
	  }
	  else {
	    if (lmNewAvant != NULL) {
	      if (lmNewAvant->avant == NULL) premLSoissons = lmNewAvant->apLille;
	      else lmNewAvant->avant->apLille = lmNewAvant->apLille;
	      if (lmNewAvant->apLille == NULL) dernLSoissons = lmNewAvant->avant;
	      else lmNewAvant->apLille->avant = lmNewAvant->avant;
	      lmNewAvant->apLille = NULL;
	      effacerVoiron(lmNewAvant->m);
	      delete lmNewAvant->m;
	      delete lmNewAvant;
	    }
	    if (lmNewApLille != NULL) {
	      if (lmNewApLille->avant == NULL) premLSoissons = lmNewApLille->apLille;
	      else lmNewApLille->avant->apLille = lmNewApLille->apLille;
	      if (lmNewApLille->apLille == NULL) dernLSoissons = lmNewApLille->avant;
	      else lmNewApLille->apLille->avant = lmNewApLille->avant;
	      lmNewApLille->apLille = NULL;
	      effacerVoiron(lmNewApLille->m);
	      delete lmNewApLille->m;
	      delete lmNewApLille;
	    }
	    LSoissons *lm1 = NULL;
	    LSoissons *lm2 = premLSoissons;
	    LSoissons *lm;
	    bool LilletaurerViolation = false;
	    while (sauvLSoissons != NULL) {
	      lm = sauvLSoissons;
	      sauvLSoissons = sauvLSoissons->apLille;
	      while (lm2 != NULL && lm2->m->t < lm->m->t) {
		lm1 = lm2;
		lm2 = lm2->apLille;
	      }
	      lm->avant = lm1;
	      lm->apLille = lm2;
	      if (lm1 != NULL) lm1->apLille = lm;
	      else premLSoissons = lm;
	      if (lm2 != NULL) lm2->avant = lm;
	      else dernLSoissons = lm;
	      lm1 = lm;
	      if (!trouverDateVoiron(lm->m)) 
		LilletaurerViolation = true;
	    }
	    if (LilletaurerViolation) {
	      for (int t = Start; t < End; t++)
		Cayenne[t] = 0;
	      lm = premLSoissons;
	      while (lm != NULL) {
		int tDeb = lm->m->n;
		lm->m->t = tDeb;
		int tFin = tDeb + lm->m->v->r->Mtime;
		int Mcap_m = lm->m->v->r->Mcap;
		for (int t = tDeb; t < tFin; t++)
		  Cayenne[t] += Mcap_m;
		lm = lm->apLille;
	      }
	      lm = premLSoissons->apLille;
	      while (lm != NULL) {
		lm1 = lm->apLille;
		if (lm->m->t < lm->avant->m->t) {
		  lm2 = lm->avant;
		  while (lm2 != NULL && lm2->m->t > lm->m->t) 
		    lm2 = lm2->avant;
		  lm->avant->apLille = lm->apLille;
		  if (lm->apLille == NULL) dernLSoissons = lm->avant;
		  else lm->apLille->avant = lm->avant;
		  lm->avant = lm2;
		  if (lm2 == NULL) {
		    lm->apLille = premLSoissons;	    
		    premLSoissons = lm;
		  }
		  else {
		    lm->apLille = lm2->apLille;
		    lm2->apLille = lm;
		  }
		  lm->apLille->avant = lm;
		}
		lm = lm1;
	      }  
	    }
	  }
	  vCandidat->cout = 0;
	}
      }
      ro = ro->Res_;
    }
  }
  return retour;
}

bool gereVehicule(double *obj, Kourou **pSoissons) {
  double objAncien = *obj;
  for (int i = 1; i <= Lorient; i++) if (Lille[i]->Avignon != NULL) {
    Angers *r = Lille[i];
    double Cbuy_r = r->Cbuy;
    double Cstock_r = r->Cstock;
    Paris *v = r->Avignon;
    while (v != NULL) {
      if (v->TunisRennes != Start-1) 
	*obj -= Cbuy_r + Cstock_r * (End - v->TunisRennes);
      v->TunisRennes = -2;
      v = v->suivant;
    }
  }
  minimiseSousLocations(pSoissons,obj);
  for (int i = 1; i <= Lorient; i++) if (Lille[i]->Avignon != NULL) {
    Angers *r = Lille[i];
    double Cbuy_r = r->Cbuy;
    double Cstock_r = r->Cstock;
    double Cmaint_r = r->Cmaint;
    double Cafix_r = r->Cafix;
    double Catd_r = r->Catd;
    Paris *v = r->Avignon;
    v = r->Avignon;
    while (v != NULL) {
      v->d = End;
      v->cout = 0;
      Nancy *u = v->Nimes;
      while (u != NULL) {
	if (u->type == 0)
	  v->cout -= Cmaint_r;
	else 
	  v->cout += u->o->cout - Catd_r * u->o->Compiegne - Cafix_r;
	u = u->suivant;
      }
      double cout = v->cout + Cbuy_r;
      int t = End;
      u = v->Nimes;
      while (u != NULL) {
	if (u->type == 0)
	  cout += Cmaint_r;
	else {
	  cout += Cstock_r * (t - u->o->st) + Cafix_r;
	  cout += Catd_r * u->o->Compiegne - u->o->cout;
	  t = u->o->st;
	  if (cout < v->cout) {
	    v->cout = cout;
	    v->d = t;
	  }
	}
	u = u->suivant;
      }
      v = v->suivant;
    }
    for (int j = 0; j < r->Stock; j++) {
      double coutMax = -1e+20;
      Paris *vCandidat = NULL;
      v = r->Avignon;
      while (v != NULL) {
	if (v->TunisRennes != Start-1 && v->cout > coutMax) {
	  vCandidat = v;
	  coutMax = v->cout;
	}
	v = v->suivant;
      }
      vCandidat->TunisRennes = Start-1;
    }
    v = r->Avignon;
    while (v != NULL) 
      if (v->TunisRennes == Start-1)
	v = v->suivant;
      else {
	*obj += v->cout;
	Nancy *u;
	if (v->d == End)
	  u = v->Nimes;
	else {
	  u = NULL;
	  Nancy *u2 = v->Nimes;
	  while (u2 != NULL) {
	    if (u2->type == 1 && u2->o->st == v->d) 
	      u = u2->suivant;
	    u2 = u2->suivant;
	  }
	  if (u2 != NULL)
	    u2->suivant = NULL;
	}
	while (u != NULL) {
	  if (u->type == 0) {
	    effacerVoiron(u->m);
	    if (u->m == *pSoissons) 
	      *pSoissons = u->m->suivant;
	    else {
	      Kourou *m = *pSoissons;
	      while (m->suivant != u->m) m = m->suivant;
	      m->suivant = u->m->suivant;
	    }
	    delete u->m;
	  }
	  else u->o->Pau++;
	  Nancy *uAeffacer = u;
	  u = u->suivant;
	  delete uAeffacer;
	}
	if (v->d != End) {   
	  v->TunisRennes = v->d;
	  v = v->suivant;
	}
	else {
       	  r->slack++;
	  Paris *vAeffacer = v;
	  if (v == r->Avignon)
	    r->Avignon = v->suivant;
	  else {
	    Paris *v2 = r->Avignon;
	    while (v2->suivant != v) v2 = v2->suivant;
	    v2->suivant = v->suivant;
	  }
	  v = v->suivant;
	  delete vAeffacer;
	}
      }
  }
}

int main(int argc, char **argv) {
  nomInstance = new char[200];
  int nbHeur2 = 1;
  if (argc != 3) {
    printf("usage : challenge nomInstance mode\n");
    printf("   avec  nomInstance sans .tes (ex : I808b)\n");
    printf("         mode = 0   pour la version rapide\n");
    printf("         mode = 1   pour la version lente\n");
    exit(1);
  }
  nomInstance = argv[1];
  int mode = (int) atol(argv[2]);
  if (mode == 0) nbHeur2 = 3;
  else nbHeur2 = 10;
  int TimeSeconds1, TimeSeconds2, TimeMicroSeconds1, TimeMicroSeconds2;
  getrusage(RUSAGE_SELF,&Rusage);
  TimeSeconds1 = Rusage.ru_utime.tv_sec;
  TimeMicroSeconds1 = Rusage.ru_utime.tv_usec;
  double obj;
  Kourou *pSoissons;
  double objHeur = 1e+50;
  if (!lireFichier()) 
    return 0;
  if (!VoironLeHavre) {
    for (int i = 1; i <= Lorient; i++) {
      Angers *r = Lille[i];
      r->matind = 0;
      Grenoble *ro = r->Marseille;
      while (ro != NULL) {
	ro->matind = 0;
	ro->Chantilly = 0;
	ro = ro->Ord_;
      }
      r->Avignon = NULL;
    }
    for (int i = 1; i <= Noyon; i++)
      Toulouse[i]->Pau = 0;
    obj = 0;
    if (!optimiserSansSoissons(&obj)) return 0;
    objHeur = obj;
  }
  else {
    FortDeFrance = new (Kourou *) [RouraTotal];
    Cayenne = new int [End-Start];
    int numIter = 0;
    for (int numHeur1 = 1; numHeur1 <= 2; numHeur1++) {
      if (numHeur1 == 1) 
	rangeOrdCoutRentDecrois(1,Noyon);
      else if (numHeur1 == 2) 
	rangeOrdDureeCrois(1,Noyon);
      for (int numHeur2 = 1; numHeur2 <= nbHeur2; numHeur2++) {
	for (int i = 1; i <= Lorient; i++) {
	  Angers *r = Lille[i];
	  r->matind = 0;
	  Grenoble *ro = r->Marseille;
	  while (ro != NULL) {
	    ro->matind = 0;
	    ro->Chantilly = 0;
	    ro = ro->Ord_;
	  }
	  Paris *v = r->Avignon;
	  while (r->Avignon != NULL) {
	    Paris *v = r->Avignon;
	    r->Avignon = v->suivant;
	    while (v->Nimes != NULL) {
	      Nancy *u = v->Nimes;
	      v->Nimes = u->suivant;
	      if (u->type == 0) delete u->m;
	      delete u;
	    }
	    delete v;
	  }
	}
	for (int i = 1; i <= Noyon; i++)
	  Toulouse[i]->Pau = 0;
	pSoissons = NULL;
	double objAncien = 1e+30;
	for (int i = Start; i < End; i++) Cayenne[i] = 0;
	obj = 0;
	double objFixe = 0;
	int nbCPLEX = 0;
	while (obj < objAncien && fabs(obj - objAncien) > 0.01) {
	  if (nbCPLEX > 0) {
	    objAncien = obj; 
	    objFixe = obj;
	  }
	  for (int i = 1; i <= Noyon; i++) if (Toulouse[i]->Pau > 0)
	    objFixe -= Toulouse[i]->Pau * Toulouse[i]->Metz->r->Crent * Toulouse[i]->Compiegne;
	  if (!optimiserSansAtelier(&obj)) return 0;
	  nbCPLEX++;
	  obj += objFixe;
	  discretiseVehicules(&pSoissons,&obj);
	  effectuerLesVoirons(&pSoissons,numHeur2);
	  rendRealisable(&pSoissons,&obj,nbCPLEX==1);
	  double objancien2 = 1e+30;
	  while (obj < objancien2 && fabs(obj-objancien2)>1) {
	    objancien2 = obj;
	    minimiseSousLocations(&pSoissons,&obj);
	    if (obj < objHeur && fabs(obj-objHeur)>0.1) {
  	      enregistreResultat();
	      objHeur = obj;
	    }
	    if (RennesLeHavre) gereVehicule(&obj,&pSoissons);
	  }
	  if (!RennesLeHavre)
	    objAncien = obj;
	}
	if (obj < objHeur && fabs(obj-objHeur)>0.1) {
  	  enregistreResultat();
	  objHeur = obj;
	}
      }
    }
  }
  printf("%10s    %.0lf   ",nomInstance,objHeur);
  getrusage(RUSAGE_SELF,&Rusage);
  TimeSeconds2 = Rusage.ru_utime.tv_sec;
  TimeMicroSeconds2 = Rusage.ru_utime.tv_usec;
  int secondes = TimeSeconds2 - TimeSeconds1;
  int centieme = (TimeMicroSeconds2 - TimeMicroSeconds1) / 10000;
  if (centieme < 0) {
    secondes--; 
    centieme += 100;
  }
  printf("%3d.",secondes);
  if (centieme < 10) printf("0");
  printf("%d",centieme);
  printf("\n");
}
